/// <reference types="node" />
import { UserAgentProvider } from './user_agent_provider';
export type GraphqlRequest<TVariables> = {
    query: string;
    variables: TVariables;
};
/**
 * This class is responsible for executing GraphQL requests.
 * Serializing query and it's inputs, adding authorization headers,
 * inspecting response for errors and de-serializing output.
 */
export declare class GraphqlRequestExecutor {
    private readonly graphQlEndpoint;
    private readonly accessToken;
    private readonly userAgentProvider;
    private readonly _fetch;
    /**
     * Creates GraphQL request executor.
     */
    constructor(graphQlEndpoint: string, accessToken: string, userAgentProvider: UserAgentProvider, _fetch?: typeof fetch);
    executeGraphql: <TVariables, TReturn>(request: GraphqlRequest<TVariables>, options?: {
        userAgent?: string;
    }) => Promise<TReturn>;
}
//# sourceMappingURL=graphql_request_executor.d.ts.map