"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModelDirectiveV1 = void 0;
const name = 'model';
const definition = `
  directive @${name}(
    queries: ModelQueryMap
    mutations: ModelMutationMap
    subscriptions: ModelSubscriptionMap
    timestamps: TimestampConfiguration
  ) on OBJECT
  input ModelMutationMap {
    create: String
    update: String
    delete: String
  }
  input ModelQueryMap {
    get: String
    list: String
  }
  input ModelSubscriptionMap {
    onCreate: [String]
    onUpdate: [String]
    onDelete: [String]
    level: ModelSubscriptionLevel
  }
  enum ModelSubscriptionLevel {
    off
    public
    on
  }
  input TimestampConfiguration {
    createdAt: String
    updatedAt: String
  }
`;
const defaults = {};
exports.ModelDirectiveV1 = {
    name,
    definition,
    defaults,
};
//# sourceMappingURL=model.js.map