import { ContinuousBackupsDescription, CreateTableCommandInput, TableDescription, TimeToLiveDescription, UpdateContinuousBackupsCommandInput, UpdateTableCommandInput, UpdateTimeToLiveCommandInput, Tag as DynamoDBTag } from '@aws-sdk/client-dynamodb';
export declare const onEvent: (event: any, context: any) => Promise<void>;
export declare const isComplete: (event: any, context: any) => Promise<void>;
export declare const getLambdaTags: (functionArn: string) => Promise<Record<string, string>[]>;
type TableManagerContext = {
    invokedFunctionArn: string;
};
export declare const processIsComplete: (event: AWSCDKAsyncCustomResource.IsCompleteRequest, context: TableManagerContext) => Promise<AWSCDKAsyncCustomResource.IsCompleteResponse>;
export declare const getNextAtomicUpdate: (currentState: TableDescription, endState: CustomDDB.Input) => UpdateTableCommandInput | undefined;
export declare const getStreamUpdate: (currentState: TableDescription, endState: CustomDDB.Input) => Promise<UpdateTableCommandInput | undefined>;
export declare const getSseUpdate: (currentState: TableDescription, endState: CustomDDB.Input) => UpdateTableCommandInput | undefined;
export declare const requiresTagsUpdate: (currentTags: DynamoDBTag[], newTags?: DynamoDBTag[]) => boolean;
export declare const getDeletionProtectionUpdate: (currentState: TableDescription, endState: CustomDDB.Input) => UpdateTableCommandInput | undefined;
export declare const getTtlUpdate: (currentTTL: TimeToLiveDescription | undefined, endState: CustomDDB.Input) => UpdateTimeToLiveCommandInput | undefined;
export declare const getPointInTimeRecoveryUpdate: (currentPointInTime: ContinuousBackupsDescription | undefined, endState: CustomDDB.Input) => UpdateContinuousBackupsCommandInput | undefined;
export declare const extractTableInputFromEvent: (event: AWSCDKAsyncCustomResource.OnEventRequest | AWSCDKAsyncCustomResource.IsCompleteRequest, context: TableManagerContext) => Promise<CustomDDB.Input>;
export declare const extractOldTableInputFromEvent: (event: AWSCDKAsyncCustomResource.OnEventRequest | AWSCDKAsyncCustomResource.IsCompleteRequest) => CustomDDB.Input;
export declare const toCreateTableInput: (props: CustomDDB.Input) => CreateTableCommandInput;
export declare const isTtlModified: (oldTtl: CustomDDB.TimeToLiveSpecificationProperty | undefined, endTtl: CustomDDB.TimeToLiveSpecificationProperty | undefined) => boolean;
export {};
//# sourceMappingURL=amplify-table-manager-handler.d.ts.map