import { FunctionRuntimeTemplate } from '@aws-amplify/graphql-transformer-interfaces';
import { BaseDataSource, CfnFunctionConfiguration } from 'aws-cdk-lib/aws-appsync';
import { Construct } from 'constructs';
import { GraphQLApi } from './graphql-api';
export interface BaseFunctionConfigurationProps {
    readonly description?: string;
    readonly mappingTemplate: FunctionRuntimeTemplate;
}
export interface FunctionConfigurationProps extends BaseFunctionConfigurationProps {
    readonly api: GraphQLApi;
    readonly dataSource: BaseDataSource | string;
    readonly runtime: CfnFunctionConfiguration.AppSyncRuntimeProperty | undefined;
}
export declare class AppSyncFunctionConfiguration extends Construct {
    readonly arn: string;
    readonly functionId: string;
    private function;
    constructor(scope: Construct, id: string, props: FunctionConfigurationProps);
}
//# sourceMappingURL=appsync-function.d.ts.map